﻿using System.ComponentModel;

namespace TestProject
{
    /// <summary>
    /// 사람
    /// </summary>
    public class Person : INotifyPropertyChanged
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 속성 변경시 이벤트 - PropertyChanged

        /// <summary>
        /// 속성 변경시 이벤트
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 회사명
        /// <summary>
        private string companyName;

        /// <summary>
        /// 이름
        /// <summary>
        private string firstName;

        /// <summary>
        /// 성
        /// <summary>
        private string lastName;

        /// <summary>
        /// 이메일 주소
        /// <summary>
        private string emailAddress;

        /// <summary>
        /// 전화
        /// <summary>
        private string phone;

        /// <summary>
        /// 영업 담당
        /// <summary>
        private string salesPerson;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 회사명 - CompanyName

        /// <summary>
        /// 회사명
        /// </summary>
        public string CompanyName
        {
            get
            {
                return this.companyName;
            }
            set
            {
                if(this.companyName == value)
                {
                    return;
                }

                this.companyName = value;

                FirePropertyChangedEvent(nameof(CompanyName));
            }
        }

        #endregion
        #region 이름 - FirstName

        /// <summary>
        /// 이름
        /// </summary>
        public string FirstName
        {
            get
            {
                return this.firstName;
            }
            set
            {
                if(this.firstName == value)
                {
                    return;
                }

                this.firstName = value;

                FirePropertyChangedEvent(nameof(FirstName));
            }
        }

        #endregion
        #region 성 - LastName

        /// <summary>
        /// 성
        /// </summary>
        public string LastName
        {
            get
            {
                return this.lastName;
            }
            set
            {
                if(this.lastName == value)
                {
                    return;
                }

                this.lastName = value;

                FirePropertyChangedEvent(nameof(LastName));
            }
        }

        #endregion
        #region 이메일 주소 - EmailAddress

        /// <summary>
        /// 이메일 주소
        /// </summary>
        public string EmailAddress
        {
            get
            {
                return this.emailAddress;
            }
            set
            {
                if(this.emailAddress == value)
                {
                    return;
                }

                this.emailAddress = value;

                FirePropertyChangedEvent(nameof(EmailAddress));
            }
        }

        #endregion
        #region 전화 - Phone

        /// <summary>
        /// 전화
        /// </summary>
        public string Phone
        {
            get
            {
                return this.phone;
            }
            set
            {
                if(this.phone == value)
                {
                    return;
                }

                this.phone = value;

                FirePropertyChangedEvent(nameof(Phone));
            }
        }

        #endregion
        #region 영업 담당 - SalesPerson

        /// <summary>
        /// 영업 담당
        /// </summary>
        public string SalesPerson
        {
            get
            {
                return this.salesPerson;
            }
            set
            {
                if(this.salesPerson == value)
                {
                    return;
                }

                this.salesPerson = value;

                FirePropertyChangedEvent(nameof(SalesPerson));
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 속성 변경시 이벤트 발생시키기 - FirePropertyChangedEvent(propertyName)

        /// <summary>
        /// 속성 변경시 이벤트 발생시키기
        /// </summary>
        /// <param name="propertyName">속성명</param>
        protected void FirePropertyChangedEvent(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}